
/* ex: set ro:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from 'nqp_bigint.ops' (and possibly other
 * .ops files). by ops2c.nqp.
 *
 * Any changes made here will be lost!  To regenerate this file after making
 * changes to any ops, use the bootstrap-ops makefile target.
 *
 */
#define PARROT_IN_EXTENSION

#include "nqp_bigint_ops.h"
#include "parrot/pbcversion.h"
#include "pmc/pmc_parrotlibrary.h"
#include "pmc/pmc_callcontext.h"


/* defines - Ops::Trans::C */
#define REL_PC     ((size_t)(cur_opcode - (opcode_t *)interp->code->base.data))
#define CUR_OPCODE cur_opcode
#define IREG(i) REG_INT(interp, cur_opcode[i])
#define NREG(i) REG_NUM(interp, cur_opcode[i])
#define PREG(i) REG_PMC(interp, cur_opcode[i])
#define SREG(i) REG_STR(interp, cur_opcode[i])
#define ICONST(i) cur_opcode[i]
#define NCONST(i) Parrot_pcc_get_num_constants(interp, interp->ctx)[cur_opcode[i]]
#define SCONST(i) Parrot_pcc_get_str_constants(interp, interp->ctx)[cur_opcode[i]]
#undef  PCONST
#define PCONST(i) Parrot_pcc_get_pmc_constants(interp, interp->ctx)[cur_opcode[i]]

static int get_op(PARROT_INTERP, const char * name, int full);


/* XXX should be static, but C++ doesn't want to play ball */
extern op_lib_t nqp_bigint_op_lib;



/* Parroty includes. */
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "../6model/sixmodelobject.h"
#include "../6model/reprs/P6bigint.h"

/* The ID of the bigint REPR. */
static INTVAL bigint_repr_id = 0;

static mp_int * get_bigint(PARROT_INTERP, PMC *obj) {
    struct SixModel_REPROps *r = REPR(obj);
    if (r->ID == bigint_repr_id)
        return &((P6bigintInstance *)PMC_data(obj))->body.i;
    else
        return &((P6bigintBody *)r->box_funcs->get_boxed_ref(interp, STABLE(obj), OBJECT_BODY(obj),
            bigint_repr_id))->i;
}

static FLOATVAL mp_get_double(mp_int *a) {
    FLOATVAL d    = 0.0;
    FLOATVAL sign = SIGN(a) == MP_NEG ? -1.0 : 1.0;
    int i;
    if (USED(a) == 0)
        return d;
    if (USED(a) == 1)
        return sign * (FLOATVAL) DIGIT(a, 0);

    mp_clamp(a);
    i = USED(a) - 1;
    d = (FLOATVAL) DIGIT(a, i);
    i--;
    if (i == -1) {
        return sign * d;
    }
    d *= pow(2.0, DIGIT_BIT);
    d += (FLOATVAL) DIGIT(a, i);

    if (USED(a) > 2) {
        i--;
        d *= pow(2.0, DIGIT_BIT);
        d += (FLOATVAL) DIGIT(a, i);
    }

    d *= pow(2.0, DIGIT_BIT * i);
    return sign * d;
}


static void from_num(FLOATVAL d, mp_int *a) {
    FLOATVAL d_digit = pow(2, DIGIT_BIT);
    FLOATVAL da      = fabs(d);
    FLOATVAL upper;
    FLOATVAL lower;
    FLOATVAL lowest;
    FLOATVAL rest;
    int      digits  = 0;

    mp_zero(a);

    while (da > d_digit * d_digit * d_digit) {;
        da /= d_digit;
        digits++;
    }
    mp_grow(a, digits + 3);

    /* populate the top 3 digits */
    upper = da / (d_digit*d_digit);
    rest = fmod(da, d_digit*d_digit);
    lower = rest / d_digit;
    lowest = fmod(rest,d_digit );
    if (upper >= 1) {
        mp_set_long(a, (unsigned long) upper);
        mp_mul_2d(a, DIGIT_BIT , a);
        DIGIT(a, 0) = (mp_digit) lower;
        mp_mul_2d(a, DIGIT_BIT , a);
    } else {
        if (lower >= 1) {
            mp_set_long(a, (unsigned long) lower);
            mp_mul_2d(a, DIGIT_BIT , a);
            a->used = 2;
        } else {
            a->used = 1;
        }
    }
    DIGIT(a, 0) = (mp_digit) lowest;

    /* shift the rest */
    mp_mul_2d(a, DIGIT_BIT * digits, a);
    if (d < 0)
        mp_neg(a, a);
    mp_clamp(a);
    mp_shrink(a);
}

static void grow_and_negate(mp_int *a, int size, mp_int *b) {
    int i;
    int actual_size = MAX(size, USED(a));
    mp_zero(b);
    mp_grow(b, actual_size);
    USED(b) = actual_size;
    for (i = 0; i < actual_size; i++) {
        DIGIT(b, i) = (~DIGIT(a, i)) & MP_MASK;
    }
    mp_add_d(b, 1, b);
}


static void two_complement_bitop(mp_int *a, mp_int *b, mp_int *c,
        int (*mp_bitop)(mp_int *, mp_int *, mp_int *)) {
    mp_int d;
    if (SIGN(a) ^ SIGN(b)) {
        /* exactly one of them is negative, so need to perform
         * some magic. tommath stores a sign bit, but Perl 6 expects
         * 2's complement */
        mp_init(&d);
        if (MP_NEG == SIGN(a)) {
            grow_and_negate(a, USED(b), &d);
            mp_bitop(&d, b, c);
        } else {
            grow_and_negate(b, USED(a), &d);
            mp_bitop(a, &d, c);
        }
        if (DIGIT(c, USED(c) - 1) & ((mp_digit)1<<(mp_digit)(DIGIT_BIT - 1))) {
            grow_and_negate(c, c->used, &d);
            mp_copy(&d, c);
            mp_neg(c, c);
        }
        mp_clear(&d);
    } else {
        mp_bitop(a, b, c);
    }

}




INTVAL nqp_bigint_numops = 58;

/*
** Op Function Table:
*/

static op_func_t nqp_bigint_op_func_table[58] = {
  Parrot_nqp_bigint_setup,                           /*      0 */
  Parrot_nqp_bigint_add_p_p_p_p,                     /*      1 */
  Parrot_nqp_bigint_sub_p_p_p_p,                     /*      2 */
  Parrot_nqp_bigint_mul_p_p_p_p,                     /*      3 */
  Parrot_nqp_bigint_div_p_p_p_p,                     /*      4 */
  Parrot_nqp_bigint_mod_p_p_p_p,                     /*      5 */
  Parrot_nqp_bigint_exp_mod_p_p_p_p_p,               /*      6 */
  Parrot_nqp_bigint_is_prime_i_p_i,                  /*      7 */
  Parrot_nqp_bigint_is_prime_i_p_ic,                 /*      8 */
  Parrot_nqp_bigint_rand_p_p_p,                      /*      9 */
  Parrot_nqp_bigint_neg_p_p_p,                       /*     10 */
  Parrot_nqp_bigint_abs_p_p_p,                       /*     11 */
  Parrot_nqp_bigint_cmp_i_p_p,                       /*     12 */
  Parrot_nqp_bigint_bool_i_p,                        /*     13 */
  Parrot_nqp_bigint_eq_i_p_p,                        /*     14 */
  Parrot_nqp_bigint_ne_i_p_p,                        /*     15 */
  Parrot_nqp_bigint_gt_i_p_p,                        /*     16 */
  Parrot_nqp_bigint_ge_i_p_p,                        /*     17 */
  Parrot_nqp_bigint_lt_i_p_p,                        /*     18 */
  Parrot_nqp_bigint_le_i_p_p,                        /*     19 */
  Parrot_nqp_bigint_gcd_p_p_p_p,                     /*     20 */
  Parrot_nqp_bigint_lcm_p_p_p_p,                     /*     21 */
  Parrot_nqp_bigint_from_str_p_s_p,                  /*     22 */
  Parrot_nqp_bigint_from_str_p_sc_p,                 /*     23 */
  Parrot_nqp_bigint_to_str_s_p,                      /*     24 */
  Parrot_nqp_bigint_to_str_base_s_p_i,               /*     25 */
  Parrot_nqp_bigint_to_str_base_s_p_ic,              /*     26 */
  Parrot_nqp_bigint_to_num_n_p,                      /*     27 */
  Parrot_nqp_bigint_from_num_p_n_p,                  /*     28 */
  Parrot_nqp_bigint_from_num_p_nc_p,                 /*     29 */
  Parrot_nqp_bigint_div_num_n_p_p,                   /*     30 */
  Parrot_nqp_bigint_shr_p_p_i_p,                     /*     31 */
  Parrot_nqp_bigint_shr_p_p_ic_p,                    /*     32 */
  Parrot_nqp_bigint_shl_p_p_i_p,                     /*     33 */
  Parrot_nqp_bigint_shl_p_p_ic_p,                    /*     34 */
  Parrot_nqp_bigint_band_p_p_p_p,                    /*     35 */
  Parrot_nqp_bigint_bor_p_p_p_p,                     /*     36 */
  Parrot_nqp_bigint_bxor_p_p_p_p,                    /*     37 */
  Parrot_nqp_bigint_bnot_p_p_p,                      /*     38 */
  Parrot_nqp_bigint_radix_p_i_s_i_i_p,               /*     39 */
  Parrot_nqp_bigint_radix_p_ic_s_i_i_p,              /*     40 */
  Parrot_nqp_bigint_radix_p_i_sc_i_i_p,              /*     41 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_i_p,             /*     42 */
  Parrot_nqp_bigint_radix_p_i_s_ic_i_p,              /*     43 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_i_p,             /*     44 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_i_p,             /*     45 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p,            /*     46 */
  Parrot_nqp_bigint_radix_p_i_s_i_ic_p,              /*     47 */
  Parrot_nqp_bigint_radix_p_ic_s_i_ic_p,             /*     48 */
  Parrot_nqp_bigint_radix_p_i_sc_i_ic_p,             /*     49 */
  Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p,            /*     50 */
  Parrot_nqp_bigint_radix_p_i_s_ic_ic_p,             /*     51 */
  Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p,            /*     52 */
  Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p,            /*     53 */
  Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p,           /*     54 */
  Parrot_nqp_bigint_pow_p_p_p_p_p,                   /*     55 */
  Parrot_nqp_bigint_is_big_i_p,                      /*     56 */

  NULL /* NULL function pointer */
};



/*
** Op Info Table:
*/

static op_info_t nqp_bigint_op_info_table[58] = {
  { /* 0 */
    "nqp_bigint_setup",
    "nqp_bigint_setup",
    "Parrot_nqp_bigint_setup",
    0,
    1,
    { (arg_type_t) 0 },
    { (arg_dir_t) 0 },
    { 0 },
    &nqp_bigint_op_lib
  },
  { /* 1 */
    "nqp_bigint_add",
    "nqp_bigint_add_p_p_p_p",
    "Parrot_nqp_bigint_add_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 2 */
    "nqp_bigint_sub",
    "nqp_bigint_sub_p_p_p_p",
    "Parrot_nqp_bigint_sub_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 3 */
    "nqp_bigint_mul",
    "nqp_bigint_mul_p_p_p_p",
    "Parrot_nqp_bigint_mul_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 4 */
    "nqp_bigint_div",
    "nqp_bigint_div_p_p_p_p",
    "Parrot_nqp_bigint_div_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 5 */
    "nqp_bigint_mod",
    "nqp_bigint_mod_p_p_p_p",
    "Parrot_nqp_bigint_mod_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 6 */
    "nqp_bigint_exp_mod",
    "nqp_bigint_exp_mod_p_p_p_p_p",
    "Parrot_nqp_bigint_exp_mod_p_p_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 7 */
    "nqp_bigint_is_prime",
    "nqp_bigint_is_prime_i_p_i",
    "Parrot_nqp_bigint_is_prime_i_p_i",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_I },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 8 */
    "nqp_bigint_is_prime",
    "nqp_bigint_is_prime_i_p_ic",
    "Parrot_nqp_bigint_is_prime_i_p_ic",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_IC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 9 */
    "nqp_bigint_rand",
    "nqp_bigint_rand_p_p_p",
    "Parrot_nqp_bigint_rand_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 10 */
    "nqp_bigint_neg",
    "nqp_bigint_neg_p_p_p",
    "Parrot_nqp_bigint_neg_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 11 */
    "nqp_bigint_abs",
    "nqp_bigint_abs_p_p_p",
    "Parrot_nqp_bigint_abs_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 12 */
    "nqp_bigint_cmp",
    "nqp_bigint_cmp_i_p_p",
    "Parrot_nqp_bigint_cmp_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 13 */
    "nqp_bigint_bool",
    "nqp_bigint_bool_i_p",
    "Parrot_nqp_bigint_bool_i_p",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 14 */
    "nqp_bigint_eq",
    "nqp_bigint_eq_i_p_p",
    "Parrot_nqp_bigint_eq_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 15 */
    "nqp_bigint_ne",
    "nqp_bigint_ne_i_p_p",
    "Parrot_nqp_bigint_ne_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 16 */
    "nqp_bigint_gt",
    "nqp_bigint_gt_i_p_p",
    "Parrot_nqp_bigint_gt_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 17 */
    "nqp_bigint_ge",
    "nqp_bigint_ge_i_p_p",
    "Parrot_nqp_bigint_ge_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 18 */
    "nqp_bigint_lt",
    "nqp_bigint_lt_i_p_p",
    "Parrot_nqp_bigint_lt_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 19 */
    "nqp_bigint_le",
    "nqp_bigint_le_i_p_p",
    "Parrot_nqp_bigint_le_i_p_p",
    0,
    4,
    { PARROT_ARG_I, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 20 */
    "nqp_bigint_gcd",
    "nqp_bigint_gcd_p_p_p_p",
    "Parrot_nqp_bigint_gcd_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 21 */
    "nqp_bigint_lcm",
    "nqp_bigint_lcm_p_p_p_p",
    "Parrot_nqp_bigint_lcm_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 22 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_s_p",
    "Parrot_nqp_bigint_from_str_p_s_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_S, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 23 */
    "nqp_bigint_from_str",
    "nqp_bigint_from_str_p_sc_p",
    "Parrot_nqp_bigint_from_str_p_sc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_SC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 24 */
    "nqp_bigint_to_str",
    "nqp_bigint_to_str_s_p",
    "Parrot_nqp_bigint_to_str_s_p",
    0,
    3,
    { PARROT_ARG_S, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 25 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_p_i",
    "Parrot_nqp_bigint_to_str_base_s_p_i",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_P, PARROT_ARG_I },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 26 */
    "nqp_bigint_to_str_base",
    "nqp_bigint_to_str_base_s_p_ic",
    "Parrot_nqp_bigint_to_str_base_s_p_ic",
    0,
    4,
    { PARROT_ARG_S, PARROT_ARG_P, PARROT_ARG_IC },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 27 */
    "nqp_bigint_to_num",
    "nqp_bigint_to_num_n_p",
    "Parrot_nqp_bigint_to_num_n_p",
    0,
    3,
    { PARROT_ARG_N, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 28 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_n_p",
    "Parrot_nqp_bigint_from_num_p_n_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_N, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 29 */
    "nqp_bigint_from_num",
    "nqp_bigint_from_num_p_nc_p",
    "Parrot_nqp_bigint_from_num_p_nc_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_NC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 30 */
    "nqp_bigint_div_num",
    "nqp_bigint_div_num_n_p_p",
    "Parrot_nqp_bigint_div_num_n_p_p",
    0,
    4,
    { PARROT_ARG_N, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 31 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_i_p",
    "Parrot_nqp_bigint_shr_p_p_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 32 */
    "nqp_bigint_shr",
    "nqp_bigint_shr_p_p_ic_p",
    "Parrot_nqp_bigint_shr_p_p_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 33 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_i_p",
    "Parrot_nqp_bigint_shl_p_p_i_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 34 */
    "nqp_bigint_shl",
    "nqp_bigint_shl_p_p_ic_p",
    "Parrot_nqp_bigint_shl_p_p_ic_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 35 */
    "nqp_bigint_band",
    "nqp_bigint_band_p_p_p_p",
    "Parrot_nqp_bigint_band_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 36 */
    "nqp_bigint_bor",
    "nqp_bigint_bor_p_p_p_p",
    "Parrot_nqp_bigint_bor_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 37 */
    "nqp_bigint_bxor",
    "nqp_bigint_bxor_p_p_p_p",
    "Parrot_nqp_bigint_bxor_p_p_p_p",
    0,
    5,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 38 */
    "nqp_bigint_bnot",
    "nqp_bigint_bnot_p_p_p",
    "Parrot_nqp_bigint_bnot_p_p_p",
    0,
    4,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 39 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_i_p",
    "Parrot_nqp_bigint_radix_p_i_s_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 40 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_i_p",
    "Parrot_nqp_bigint_radix_p_ic_s_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 41 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_i_p",
    "Parrot_nqp_bigint_radix_p_i_sc_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 42 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_i_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 43 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_i_p",
    "Parrot_nqp_bigint_radix_p_i_s_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 44 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_i_p",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 45 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_i_p",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 46 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_i_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 47 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_i_ic_p",
    "Parrot_nqp_bigint_radix_p_i_s_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 48 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_i_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_s_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 49 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_i_ic_p",
    "Parrot_nqp_bigint_radix_p_i_sc_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 50 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_i_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_I, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 51 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_s_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_i_s_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 52 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_s_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_S, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 53 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_i_sc_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_I, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 54 */
    "nqp_bigint_radix",
    "nqp_bigint_radix_p_ic_sc_ic_ic_p",
    "Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p",
    0,
    7,
    { PARROT_ARG_P, PARROT_ARG_IC, PARROT_ARG_SC, PARROT_ARG_IC, PARROT_ARG_IC, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 55 */
    "nqp_bigint_pow",
    "nqp_bigint_pow_p_p_p_p_p",
    "Parrot_nqp_bigint_pow_p_p_p_p_p",
    0,
    6,
    { PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN, PARROT_ARGDIR_IN },
    { 0, 0, 0, 0, 0 },
    &nqp_bigint_op_lib
  },
  { /* 56 */
    "nqp_bigint_is_big",
    "nqp_bigint_is_big_i_p",
    "Parrot_nqp_bigint_is_big_i_p",
    0,
    3,
    { PARROT_ARG_I, PARROT_ARG_P },
    { PARROT_ARGDIR_OUT, PARROT_ARGDIR_IN },
    { 0, 0 },
    &nqp_bigint_op_lib
  },

};


/*
** Op Function Definitions:
*/

opcode_t *
Parrot_nqp_bigint_setup(opcode_t *cur_opcode, PARROT_INTERP) {
    if ((!bigint_repr_id)) {
        bigint_repr_id = REGISTER_DYNAMIC_REPR(interp, Parrot_str_new_constant(interp, "P6bigint"), P6bigint_initialize);
        srand((unsigned int)Parrot_util_int_rand(0));
    }

    return cur_opcode + 1;
}

opcode_t *
Parrot_nqp_bigint_add_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_add(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_sub_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_sub(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mul_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mul(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_div_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   result;

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    result = mp_div(a, b, get_bigint(interp, PREG(1)), NULL);
    if ((result == MP_VAL)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Divide by zero");
    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_mod_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_mod(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_exp_mod_p_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    mp_int  * c = get_bigint(interp, PREG(4));

    PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_exptmod(a, b, c, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_is_prime_i_p_i(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    if ((mp_cmp_d(a, 1) == MP_EQ)) {
        IREG(1) = 0;
    }
    else {
        int   result;

        mp_prime_is_prime(a, IREG(3), (&result));
        IREG(1) = result;
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_is_prime_i_p_ic(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    if ((mp_cmp_d(a, 1) == MP_EQ)) {
        IREG(1) = 0;
    }
    else {
        int   result;

        mp_prime_is_prime(a, ICONST(3), (&result));
        IREG(1) = result;
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_rand_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = NULL;

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_rand(b, (USED(a) + 1));
    mp_mod(b, a, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_neg_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_neg(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_abs_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_abs(a, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_cmp_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = mp_cmp(a, b);
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_bool_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    IREG(1) = (!mp_iszero(get_bigint(interp, PREG(2))));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_eq_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ne_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_EQ != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gt_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_ge_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_lt_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_LT == mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_le_i_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    IREG(1) = (MP_GT != mp_cmp(a, b));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_gcd_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_gcd(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_lcm_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_lcm(a, b, get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_s_p(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SREG(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_str_p_sc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    const char  * buf = Parrot_str_cstring(interp, SCONST(2));

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_read_radix(get_bigint(interp, PREG(1)), buf, 10);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_s_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, 10, (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, 10, len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_p_i(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, IREG(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, IREG(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_str_base_s_p_ic(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * i = get_bigint(interp, PREG(2));
    int   len;
    char  * buf;

    mp_radix_size(i, ICONST(3), (&len));
    buf = (char *)mem_sys_allocate(len);
    mp_toradix_n(i, buf, ICONST(3), len);
    SREG(1) = Parrot_str_new(interp, buf, (len - 1));
    mem_sys_free(buf);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_to_num_n_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int   * a = get_bigint(interp, PREG(2));

    NREG(1) = mp_get_double(a);
    return cur_opcode + 3;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_n_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NREG(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_from_num_p_nc_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    from_num(NCONST(2), get_bigint(interp, PREG(1)));
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_div_num_n_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));
    int   max_size = (DIGIT_BIT * MAX(USED(a), USED(b)));

    if ((max_size > 1023)) {
        mp_int   reduced_a;
        mp_int   reduced_b;

        mp_init((&reduced_a));
        mp_init((&reduced_b));
        mp_div_2d(a, (max_size - 1023), (&reduced_a), NULL);
        mp_div_2d(b, (max_size - 1023), (&reduced_b), NULL);
        NREG(1) = (mp_get_double((&reduced_a)) / mp_get_double((&reduced_b)));
        mp_clear((&reduced_a));
        mp_clear((&reduced_b));
    }
    else {
        NREG(1) = (mp_get_double(a) / mp_get_double(b));
    }

    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, IREG(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shr_p_p_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    mp_div_2d(a, ICONST(3), get_bigint(interp, PREG(1)), NULL);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, IREG(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_shl_p_p_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * b;
    mp_int  * a = get_bigint(interp, PREG(2));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_mul_2d(a, ICONST(3), b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_band_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_and);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bor_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_or);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bxor_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b = get_bigint(interp, PREG(3));

    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    two_complement_bitop(a, b, get_bigint(interp, PREG(1)), mp_xor);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 5;
}

opcode_t *
Parrot_nqp_bigint_bnot_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));
    mp_int  * b;

    PREG(1) = REPR(PREG(3))->allocate(interp, STABLE(PREG(3)));
    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
    b = get_bigint(interp, PREG(1));
    mp_add_d(a, 1, b);
    mp_neg(b, b);
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 4;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = IREG(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_i_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = IREG(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_s_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_s_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SREG(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_i_sc_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = IREG(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_radix_p_ic_sc_ic_ic_p(opcode_t *cur_opcode, PARROT_INTERP) {
    PMC       * out;
    INTVAL     radix = ICONST(2);
    STRING    * str = SCONST(3);
    INTVAL     zpos = ICONST(4);
    INTVAL     flags = ICONST(5);
    INTVAL     chars = Parrot_str_length(interp, str);
    int        neg = 0;
    INTVAL     ch;
    mp_int     zvalue;
    mp_int     zbase;
    PMC       * value_obj;
    mp_int    * value;
    PMC       * base_obj;
    mp_int    * base;
    PMC       * pos_obj;
    INTVAL     pos = (-1);

    if ((radix > 36)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION, "Cannot convert radix of %d (max 36)", radix);
    }

    mp_init((&zvalue));
    mp_init((&zbase));
    mp_set_int((&zbase), 1);
    value_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(value_obj)->initialize(interp, STABLE(value_obj), OBJECT_BODY(value_obj));
    value = get_bigint(interp, value_obj);
    base_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(base_obj)->initialize(interp, STABLE(base_obj), OBJECT_BODY(base_obj));
    base = get_bigint(interp, base_obj);
    mp_set_int(base, 1);
    ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    if ((((flags & 0x02)) && (((ch == '+') || (ch == '-'))))) {
        neg = ((ch == '-'));
        (zpos++);
        ch = ((zpos < chars)) ? STRING_ord(interp, str, zpos) : 0;
    }

    while ((zpos < chars)) {
        if (((ch >= '0') && (ch <= '9'))) {
            ch = (ch - '0');
        }
        else {
            if (((ch >= 'a') && (ch <= 'z'))) {
                ch = ((ch - 'a') + 10);
            }
            else {
                if (((ch >= 'A') && (ch <= 'Z'))) {
                    ch = ((ch - 'A') + 10);
                }
                else {
                    break;
                }

            }

        }

        if ((ch >= radix)) {
            break;
        }

        mp_mul_d((&zvalue), radix, (&zvalue));
        mp_add_d((&zvalue), ch, (&zvalue));
        mp_mul_d((&zbase), radix, (&zbase));
        (zpos++);
        pos = zpos;
        if (((ch != 0) || (!((flags & 0x04))))) {
            mp_copy((&zvalue), value);
            mp_copy((&zbase), base);
        }

        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
        if ((ch != '_')) {
            continue;
        }

        (zpos++);
        if ((zpos >= chars)) {
            break;
        }

        ch = STRING_ord(interp, str, zpos);
    }

    mp_clear((&zvalue));
    mp_clear((&zbase));
    pos_obj = REPR(PREG(6))->allocate(interp, STABLE(PREG(6)));
    REPR(pos_obj)->initialize(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj));
    REPR(pos_obj)->box_funcs->set_int(interp, STABLE(pos_obj), OBJECT_BODY(pos_obj), pos);
    if ((neg || (flags & 0x01))) {
        mp_neg(value, value);
    }

    out = Parrot_pmc_new(interp, enum_class_FixedPMCArray);
    VTABLE_set_integer_native(interp, out, 3);
    VTABLE_set_pmc_keyed_int(interp, out, 0, value_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 1, base_obj);
    VTABLE_set_pmc_keyed_int(interp, out, 2, pos_obj);
    PREG(1) = out;
    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 7;
}

opcode_t *
Parrot_nqp_bigint_pow_p_p_p_p_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_digit   exponent_d = 0;
    mp_int  * exponent = get_bigint(interp, PREG(3));
    mp_int  * base = get_bigint(interp, PREG(2));
    int   cmp = mp_cmp_d(exponent, 0);

    if (((cmp == MP_EQ) || (MP_EQ == mp_cmp_d(base, 1)))) {
        PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
        REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
        mp_set_int(get_bigint(interp, PREG(1)), 1);
    }
    else {
        if ((cmp == MP_GT)) {
            exponent_d = mp_get_int(exponent);
            if ((MP_GT == mp_cmp_d(exponent, exponent_d))) {
                cmp = mp_cmp_d(base, 0);
                if (((MP_EQ == cmp) || (MP_EQ == mp_cmp_d(base, 1)))) {
                    PREG(1) = REPR(PREG(2))->allocate(interp, STABLE(PREG(2)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    mp_copy(base, get_bigint(interp, PREG(1)));
                }
                else {
                    FLOATVAL   ZERO = 0.0;

                    PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
                    REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                    if ((MP_GT == cmp)) {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)1.0 / ZERO));
                    }
                    else {
                        REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), ((FLOATVAL)(-1.0) / ZERO));
                    }

                }

            }
            else {
                PREG(1) = REPR(PREG(5))->allocate(interp, STABLE(PREG(5)));
                REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
                mp_expt_d(get_bigint(interp, PREG(2)), exponent_d, get_bigint(interp, PREG(1)));
            }

        }
        else {
            FLOATVAL   f_base = mp_get_double(base);
            FLOATVAL   f_exp = mp_get_double(exponent);

            PREG(1) = REPR(PREG(4))->allocate(interp, STABLE(PREG(4)));
            REPR(PREG(1))->initialize(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)));
            REPR(PREG(1))->box_funcs->set_num(interp, STABLE(PREG(1)), OBJECT_BODY(PREG(1)), pow(f_base, f_exp));
        }

    }

    PARROT_GC_WRITE_BARRIER(interp, CURRENT_CONTEXT(interp));
    return cur_opcode + 6;
}

opcode_t *
Parrot_nqp_bigint_is_big_i_p(opcode_t *cur_opcode, PARROT_INTERP) {
    mp_int  * a = get_bigint(interp, PREG(2));

    IREG(1) = (a->used > 1);
    if ((((((sizeof(INTVAL) * 8) < DIGIT_BIT) && (IREG(1) == 0)) && DIGIT(a, 0)) & (~0x7FFFFFFFUL))) {
        IREG(1) = 1;
    }

    return cur_opcode + 3;
}


/*
** op lib descriptor:
*/

/* XXX should be static, but C++ doesn't want to play ball */
op_lib_t nqp_bigint_op_lib = {
  "nqp_bigint_ops",                /* name */
  "",                  /* suffix */
  PARROT_FUNCTION_CORE,                       /* core_type = PARROT_XX_CORE */
  0,                                /* flags */
  PARROT_PBC_MAJOR,
  PARROT_PBC_MINOR,
  57,             /* op_count */
  nqp_bigint_op_info_table,       /* op_info_table */
  nqp_bigint_op_func_table,       /* op_func_table */
  get_op          /* op_code() */ 
};

/*
** Op lookup function:
*/

#define OP_HASH_SIZE 3041

/* we could calculate a prime somewhat bigger than
 * n of fullnames + n of names
 * for now this should be ok
 *
 * look up an op_code: at first call to op_code() a hash
 * of short and full opcode names is created
 * hash functions are from imcc, thanks to Melvin.
 */


typedef struct hop {
    op_info_t * info;
    struct hop *next;
} HOP;

static HOP *hop_buckets;
static HOP **hop;

static void hop_init(PARROT_INTERP);
static size_t hash_str(ARGIN(const char *str));
static void store_op(ARGIN(op_info_t *info), ARGMOD(HOP *p), ARGIN(const char *name));

/* XXX on changing interpreters, this should be called,
   through a hook */

static void hop_deinit(PARROT_INTERP);

/*
 * find a short or full opcode
 * usage:
 *
 * interp->op_lib->op_code("set", 0)
 * interp->op_lib->op_code("set_i_i", 1)
 *
 * returns >= 0 (found idx into info_table), -1 if not
 */

PARROT_PURE_FUNCTION
static
size_t hash_str(ARGIN(const char *str))
{
    size_t      key = 0;
    const char *s   = str;

    while (*s) {
        key *= 65599;
        key += *s++;
    }

    return key;
}


static void store_op(ARGIN(op_info_t *info), ARGMOD(HOP *p), ARGIN(const char *name))
{
    const size_t hidx = hash_str(name) % OP_HASH_SIZE;

    p->info           = info;
    p->next           = hop[hidx];
    hop[hidx]         = p;
}

static int get_op(PARROT_INTERP, ARGIN(const char *name), int full)
{
    const HOP   *p;
    const size_t hidx = hash_str(name) % OP_HASH_SIZE;

    if (!hop) {
        hop = mem_gc_allocate_n_zeroed_typed(interp, OP_HASH_SIZE,HOP *);
        hop_init(interp);
    }

    for (p = hop[hidx]; p; p = p->next) {
        if (STREQ(name, full ? p->info->full_name : p->info->name))
            return p->info - nqp_bigint_op_lib.op_info_table;
    }

    return -1;
}


static void hop_init(PARROT_INTERP)
{
    op_info_t * const info = nqp_bigint_op_lib.op_info_table;
    opcode_t i;

    /* allocate the storage all in one chunk
     * yes, this is profligate, but we can tighten it later */
    HOP *hops;

    hop_buckets = mem_gc_allocate_n_zeroed_typed(interp, nqp_bigint_op_lib.op_count * 2, HOP );
    hops        = hop_buckets;


    /* store full names */
    for (i = 0; i < nqp_bigint_op_lib.op_count; i++) {
        store_op(info + i, hops++, info[i].full_name);

        /* plus one short name */
        if (i && info[i - 1].name != info[i].name)
            store_op(info + i, hops++, info[i].name);
    }
}

static void hop_deinit(PARROT_INTERP)
{
    if (hop)
        mem_sys_free(hop);
    if (hop_buckets)
        mem_gc_free(interp, hop_buckets);

    hop         = NULL;
    hop_buckets = NULL;
}

op_lib_t *
PARROT_DYNOP_NQP_BIGINT_INIT(PARROT_INTERP, long init) {
    /* initialize and return op_lib ptr */
    if (init == 1) {

        return &nqp_bigint_op_lib;
    }
    /* set op_lib to the passed ptr (in init) */
    else if (init) {

    }
    /* deinit - free resources */
    else {
        hop_deinit(interp);
    }
    return NULL;
}


/*
 * dynamic lib load function - called once
 */
PARROT_DYNEXT_EXPORT PMC*
Parrot_lib_nqp_bigint_ops_load(PARROT_INTERP);

PARROT_DYNEXT_EXPORT PMC*
Parrot_lib_nqp_bigint_ops_load(PARROT_INTERP)

{
    PMC *const lib = Parrot_pmc_new(interp, enum_class_ParrotLibrary);
    ((Parrot_ParrotLibrary_attributes*)PMC_data(lib))->oplib_init = (void *) PARROT_DYNOP_NQP_BIGINT_INIT;
    dynop_register(interp, lib);
    return lib;
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 *   buffer-read-only: t
 * End:
 * vim: expandtab shiftwidth=4:
 */
